#!/bin/bash
# {{ ansible_managed }}
#
# Create a data backup of selected elasticsearch data
#

ELASTICSEARCH_URL=http://{{ elasticsearch_host }}:{{ elasticsearch_port }}
TIMESTAMP=$(date +'%Y%m%d%H%M')
INDICES={{ search_index_data_backup_elasticsearch_indices }}
BACKUP_DIR={{ search_index_data_backup_directory }}

date +"*** %Y-%m-%d %H:%M:%S Creating backup of elasticsearch data"
date +"*** %Y-%m-%d %H:%M:%S register elasticsearch repository"
read -r -d '' REGISTER_REPO_QUERY << EOC
{
  "type": "fs",
  "settings": {
    "location": "{{ search_index_data_backup_directory }}/elasticsearch/backup_${TIMESTAMP}"
  }
}
EOC
curl -s --netrc-file {{ base_dir }}/conf/search_index_elastic_backup_access -X PUT --header 'Content-Type: application/json' --header 'Accept: application/json' -d "$REGISTER_REPO_QUERY" "${ELASTICSEARCH_URL}/_snapshot/elasticsearch_backup_${TIMESTAMP}"
echo ""

date +"*** %Y-%m-%d %H:%M:%S creating snapshot"
read -r -d '' SNAPSHOT_QUERY << EOC
{
  "indices": "$INDICES",
  "ignore_unavailable": true,
  "include_global_state": false,
  "feature_states": [{% if kibana_install %}"kibana"{% endif %}],
  "metadata": {
    "taken_by": "SIDRE backup script",
    "timestamp": "$TIMESTAMP",
    "included_indices": "$INDICES"
  }
}
EOC
curl -s --netrc-file {{ base_dir }}/conf/search_index_elastic_backup_access -X PUT --header 'Content-Type: application/json' --header 'Accept: application/json' -d "$SNAPSHOT_QUERY" "${ELASTICSEARCH_URL}/_snapshot/elasticsearch_backup_${TIMESTAMP}/sidre_data?wait_for_completion=true"
echo ""

date +"*** %Y-%m-%d %H:%M:%S unregister elasticsearch repository"
curl -s --netrc-file {{ base_dir }}/conf/search_index_elastic_backup_access -X DELETE --header 'Accept: application/json' "${ELASTICSEARCH_URL}/_snapshot/elasticsearch_backup_${TIMESTAMP}"
echo ""

date +"*** %Y-%m-%d %H:%M:%S Compress elasticsearch repository"
cd ${BACKUP_DIR}
tar czf backup_${TIMESTAMP}_elasticsearch.tar.gz elasticsearch/backup_${TIMESTAMP}

date +"*** %Y-%m-%d %H:%M:%S elasticsearch data backup finished"
